<template>
  <b-container>
    <confirmation-modal ref="confirmationModal" />
    <b-alert
      v-model="showErrorMessage"
      dismissible
      variant="danger"
    >
      {{ errorMessage }}
    </b-alert>
    <b-table
      :fields="fields"
      :items="users"
    >
      <template #cell(staff)="data">
        <b-form-checkbox
          v-model="data.item.staff"
          :disabled="submitting"
          switch
          @change="$event ? grantStaff(data.item) : revokeStaff(data.item)"
        />
      </template>
      <template #cell(admin)="data">
        <b-form-checkbox
          v-model="data.item.admin"
          :disabled="submitting"
          switch
          @change="$event ? grantAdmin(data.item) : revokeAdmin(data.item)"
        />
      </template>
    </b-table>
  </b-container>
</template>

<script lang="ts">
/* eslint-disable no-param-reassign */
import Vue from 'vue';

import { UserService } from '@/api';
import { User } from '@/common/types';
import ConfirmationModal from '@/components/ConfirmationModal.vue';

export default Vue.extend({
  components: {
    ConfirmationModal,
  },

  data() {
    return {
      errorMessage: '',
      fields: [
        {
          key: 'username',
          text: 'Username',
        },
        {
          key: 'email',
          text: 'Email',
        },
        {
          key: 'name',
          text: 'Name',
        },
        {
          key: 'admin',
          text: 'Admin',
        },
        {
          key: 'staff',
          text: 'Staff',
        },
      ],
      showErrorMessage: false,
      submitting: false,
      users: [] as User[],
    };
  },

  mounted() {
    this.fetchUsers();
  },

  methods: {
    async fetchUsers() {
      ({ data: this.users } = await UserService.list({}));
    },

    async grantAdmin(user: User) {
      this.submitting = true;
      await this.$nextTick();
      const confirm = await (<any> this.$refs.confirmationModal).prompt(
        `Making ${user.username} an administrator may be a dangerous operation.`,
        user.username,
      );
      if (!confirm) {
        user.admin = false;
        this.submitting = false;
        return;
      }
      try {
        await UserService.grantAdmin(user.id);
        await this.fetchUsers();
      } catch (error) {
        this.errorMessage = error;
        this.showErrorMessage = true;
        user.admin = false;
      }
      this.submitting = false;
    },

    async grantStaff(user: User) {
      this.submitting = true;
      await this.$nextTick();
      const confirm = await (<any> this.$refs.confirmationModal).prompt(
        `Making ${user.username} staff may be a dangerous operation.`,
        user.username,
      );
      if (!confirm) {
        user.staff = false;
        this.submitting = false;
        return;
      }
      try {
        await UserService.grantStaff(user.id);
        await this.fetchUsers();
      } catch (error) {
        this.errorMessage = error;
        this.showErrorMessage = true;
        user.staff = false;
      }
      this.submitting = false;
    },

    async revokeAdmin(user: User) {
      this.submitting = true;
      await this.$nextTick();
      const confirm = await (<any> this.$refs.confirmationModal).prompt(
        `Revoking ${user.username}'s administrator privileges may be a dangerous operation.`,
        user.username,
      );
      if (!confirm) {
        user.admin = true;
        this.submitting = false;
        return;
      }
      try {
        await UserService.revokeAdmin(user.id);
        await this.fetchUsers();
      } catch (error) {
        this.errorMessage = error;
        this.showErrorMessage = true;
        user.admin = true;
      }
      this.submitting = false;
    },

    async revokeStaff(user: User) {
      this.submitting = true;
      await this.$nextTick();
      const confirm = await (<any> this.$refs.confirmationModal).prompt(
        `Revoking ${user.username}'s staff privileges may be a dangerous operation.`,
        user.username,
      );
      if (!confirm) {
        user.staff = true;
        this.submitting = false;
        return;
      }
      try {
        await UserService.revokeStaff(user.id);
        await this.fetchUsers();
      } catch (error) {
        this.errorMessage = error;
        this.showErrorMessage = true;
        user.staff = true;
      }
      this.submitting = false;
    },
  },
});
</script>

<style scoped></style>
